<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      
      <b-form
        class="p-5"
        @submit.stop.prevent
      >
      <div class = "title">
        <h4>Registrar nuevo rol</h4>
      </div>
      <br>
        <b-alert variant="warning" :show="showAlert">Hay un campo vacio</b-alert>
        <b-alert variant="warning" :show="showAlertRequest">{{errorMessageRequest}}</b-alert>
          <b-form-group
            label="Nombre del rol"
            label-for="name"
            class="w-50"
          >
            <b-form-input
              id="name" 
              v-model="formData.name"
              autofocus
              trim
              maxlength="40"
              :state="validationName"
              placeholder="Nombre del rol"
            />
            <b-form-invalid-feedback >
                Este campo es obligatorio
            </b-form-invalid-feedback>
                   

                  
          </b-form-group>
          
           <!-- PERMISSION TABLE -->
          <b-card
          no-body
          class="border mt-1"
          style="max-width: 55rem;"
          
          >
          <b-card-header class="p-1">
            <b-card-title class="font-medium-2">
              <feather-icon
                icon="LockIcon"
                size="18"
              />
              <span class="align-middle ml-50">Permisos</span>
            </b-card-title>
          </b-card-header>
            
             <b-card-text>
              <b-col >
                <permissions-table :permissions="formData.permissions"   ></permissions-table>
              </b-col>
            </b-card-text>

          </b-card>
          <div class="d-flex mt-2">
            <b-button

              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByName"
              @click="handleSubmit()"
            >
              Agregar
            </b-button>
            <b-button
  
              type="button"
              @click="$router.back()"
              variant="outline-secondary"
           
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>
    


  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, 
  BCard, BCardHeader, BCardTitle,BAlert, BLink,BTable,BFormCheckbox,BCol,BCardText
} from 'bootstrap-vue'
import PermissionsTable from '../PermissionsTables.vue'

export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    BTable,
    BFormCheckbox,
    BCardHeader,
    BCardTitle,
    PermissionsTable,
    BCol,
    BCardText

 
  },

  data(){
    return{
      formData:{
        name:'',
        permissions:[{permissionId:'1',selected:false},{permissionId:'2',selected:false},{permissionId:'3',selected:false},
          {permissionId:'4',selected:false},{permissionId:'5',selected:false},{permissionId:'6',selected:false},
          {permissionId:'7',selected:false},{permissionId:'8',selected:false},{permissionId:'9',selected:false},
          {permissionId:'10',selected:false},{permissionId:'11',selected:false},{permissionId:'12',selected:false},
          {permissionId:'13',selected:false},{permissionId:'14',selected:false},{permissionId:'15',selected:false},
          {permissionId:'16',selected:false},{permissionId:'17',selected:false},{permissionId:'18',selected:false},
          {permissionId:'19',selected:false},{permissionId:'20',selected:false},{permissionId:'21',selected:false},
          {permissionId:'22',selected:false},{permissionId:'23',selected:false},{permissionId:'24',selected:false},
          {permissionId:'25',selected:false},{permissionId:'26',selected:false},{permissionId:'27',selected:false},
          {permissionId:'28',selected:false},{permissionId:'29',selected:false},{permissionId:'30',selected:false},
          {permissionId:'31',selected:false},

        ],
        role:this.$route.params.id,

      },
   
      showAlert:false,
      showAlertRequest:false,
      hasWrittenName:false,
      hasWrittenRfc:false,
      errorMessageRequest:'',
      lockedSubmitByName:false

    }
  },
  computed: {
    validationName() {     
        return this.formData.name.length > 0;   
    },
     
  },
  methods:{
    handleSubmit(){

      if(this.formData.name===''){
          this.showAlert=true
          return
      }else{
        this.$swal({
          title: '¿Está seguro de actualizar el registro?',
          text: "Se reemplazarán los datos modificados!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {
            this.$http.post('roles/update',this.formData).then(res =>{
              this.$swal({
                  icon: 'success',
                  title: 'Guardado!',
                  text: 'El registro ha sido actualizado.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
              })
              this.$router.push({ name: 'apps-roles-list' })
            }).catch(err=>{
              if (err.response.status == 422){
                console.log('err')

              }
            })
            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'El registro esta a salvo :)',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
            
      }
    },
    cancel(){
      this.$router.push({ name: 'apps-clients-list' })
    },
    getRoleData(){
      this.$http.get('roles/show',{params:{role:this.$route.params.id}}).then(res=>{

        let permissions_request = res.data.rolePermissions
        let role_permissions = this.formData.permissions

        this.formData.name = res.data.roleName

          permissions_request.forEach( function(valor, indice, array) {
               role_permissions.forEach( function(data, indice2, array2) {
                  if(data.permissionId == valor.id){
                    data.selected = true
                  }
                });
          });

      }).catch(err=>{
        console.log(err)
      })
    },
  },
  computed: {
      validationName() {
        if(this.formData.name.length > 0 ){
          this.lockedSubmitByName = false
          return true
        }else{
          this.lockedSubmitByName = true
          return false
        }
      },
    
      
     
  },
  
  mounted(){
    this.getRoleData()
  }



}
</script>

<style>

</style>
